import json
import os

tasks = ["artwork", "celebrity", "code_reasoning", "color", "commonsense_reasoning", "count", "existence", "landmark", "numerical_calculation",
         "OCR", "position", "posters", "scene", "text_translation"]

root = "/media/gregor/DATA/projects/wuerzburg/iglue/datasets/MME"
data = []

print(len(tasks))
for task in tasks:
    taskdata = []
    task_path = os.path.join(root, task)
    content = os.listdir(task_path)
    add_images = False
    if len(content) == 2:
        text_files = os.listdir(os.path.join(task_path, "questions_answers_YN"))
        image_files = os.listdir(os.path.join(task_path, "images"))
        image_files = [f for f in image_files if ".jpg" in f or ".png" in f]
        add_images = True
    else:
        text_files = [f for f in content if ".txt" in f]
        image_files = [f for f in content if ".jpg" in f or ".png" in f]
    assert len(text_files) == len(image_files)
    assert not set(f.split(".")[0] for f in text_files).difference(set(f.split(".")[0] for f in image_files))
    extension = "."+image_files[0].split(".")[1]

    for f in text_files:
        image_id = f.split(".")[0]
        for line in open(f"{task_path}/{'questions_answers_YN/' if add_images else ''}{f}").readlines():
            context, label = line.strip().split("\t")
            entry = {
                "context": context,
                "label": "",
                "image_id": f"{task}/{'images/' if add_images else ''}{image_id}{extension}",
                "text_label": f"{task} ### {label}"
            }
            taskdata.append(entry)
    # assert all(os.path.exists(d["image_id"]) for d in taskdata)
    assert len(taskdata) % 2 == 0
    print(task, len(taskdata))
    data.extend(taskdata)


json.dump(data, open(f"mme_test.json", "w"))


data = []

for task in ["existence", "count", "color", "position"]:
    taskdata = []
    task_path = os.path.join(root, task)
    content = os.listdir(task_path)
    add_images = False
    if len(content) == 2:
        text_files = os.listdir(os.path.join(task_path, "questions_answers_YN"))
        image_files = os.listdir(os.path.join(task_path, "images"))
        image_files = [f for f in image_files if ".jpg" in f or ".png" in f]
        add_images = True
    else:
        text_files = [f for f in content if ".txt" in f]
        image_files = [f for f in content if ".jpg" in f or ".png" in f]
    assert len(text_files) == len(image_files)
    assert not set(f.split(".")[0] for f in text_files).difference(set(f.split(".")[0] for f in image_files))
    extension = "."+image_files[0].split(".")[1]

    for f in text_files:
        image_id = f.split(".")[0]
        for line in open(f"{task_path}/{'questions_answers_YN/' if add_images else ''}{f}").readlines():
            context, label = line.strip().split("\t")
            entry = {
                "context": context, #.replace("Please answer", "Answer with"),
                "label": "",
                "image_id": f"{task}/{'images/' if add_images else ''}{image_id}{extension}",
                "text_label": f"{task} ### {label}"
            }
            taskdata.append(entry)
    # assert all(os.path.exists(d["image_id"]) for d in taskdata)
    assert len(taskdata) % 2 == 0
    print(task, len(taskdata))
    data.extend(taskdata)


json.dump(data, open(f"mme_test_coarse.json", "w"))
